/**
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.sm.textual.formatting2;

import com.google.inject.Inject;
import java.util.Arrays;
import no.ntnu.tdt4250.sm.State;
import no.ntnu.tdt4250.sm.StateMachine;
import no.ntnu.tdt4250.sm.Transition;
import no.ntnu.tdt4250.sm.textual.services.StateMachineDSLGrammarAccess;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class StateMachineDSLFormatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private StateMachineDSLGrammarAccess _stateMachineDSLGrammarAccess;

  protected void _format(final StateMachine stateMachine, @Extension final IFormattableDocument document) {
    EList<State> _state = stateMachine.getState();
    for (final State state : _state) {
      document.<State>format(state);
    }
    EList<Transition> _transition = stateMachine.getTransition();
    for (final Transition transition : _transition) {
      document.<Transition>format(transition);
    }
  }

  protected void _format(final State state, @Extension final IFormattableDocument document) {
    EList<State> _children = state.getChildren();
    for (final State _state : _children) {
      document.<State>format(_state);
    }
  }

  public void format(final Object state, final IFormattableDocument document) {
    if (state instanceof XtextResource) {
      _format((XtextResource)state, document);
      return;
    } else if (state instanceof State) {
      _format((State)state, document);
      return;
    } else if (state instanceof StateMachine) {
      _format((StateMachine)state, document);
      return;
    } else if (state instanceof EObject) {
      _format((EObject)state, document);
      return;
    } else if (state == null) {
      _format((Void)null, document);
      return;
    } else if (state != null) {
      _format(state, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(state, document).toString());
    }
  }
}
